Index: /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 579)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 580)
@@ -25,11 +25,8 @@
 const float VspBspTree::sLeastRaySplitsTable[] = {0, 0, 1, 1, 0};
 /** Evaluates split plane classification with respect to the plane's
-	contribution for balanced rays.
+	contribution for  balanced rays.
 */
 const float VspBspTree::sBalancedRaysTable[] = {1, -1, 0, 0, 0};
 
-ViewCellsManager *BspMergeCandidate::sViewCellsManager = NULL;
-//int BspMergeCandidate::sMaxPvsSize = 0;
-//int BspMergeCandidate::sMinPvsSize = 0;
 
 int VspBspTree::sFrontId = 0;
@@ -37,13 +34,4 @@
 int VspBspTree::sFrontAndBackId = 0;
 
-float BspMergeCandidate::sOverallCost = 0;
-float BspMergeCandidate::sExpectedCost = 0;
-float BspMergeCandidate::sVariance = 0;
-float BspMergeCandidate::sRenderCostWeight = 0.5f;
-bool BspMergeCandidate::sUseArea = false;
-int BspMergeCandidate::sNumViewCells = 0;
-
-//int upperPvsLimit = 120;
-//int lowerPvsLimit = 5;
 
 
@@ -64,17 +52,4 @@
 
 
-// penalty for pvs durint merge
-inline float EvalPvsPenaltyForMerge(const int pvs, 
-									const int lower,
-									const int upper)
-{
-	// clamp to minmax values
-	if (pvs < lower)
-		return (float)lower;
-	if (pvs > upper)
-		return (float)upper;
-
-	return (float)pvs;
-}
 
 
@@ -90,5 +65,6 @@
 mViewCellsManager(NULL),
 mOutOfBoundsCell(NULL),
-mStoreRays(false)
+mStoreRays(false),
+mRenderCostWeight(0.5)
 {
 	bool randomize = false;
@@ -126,11 +102,5 @@
 	// if only the driving axis is used for axis aligned split
 	environment->GetBoolValue("VspBspTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
-
-	//-- merge options
-	environment->GetIntValue("VspBspTree.PostProcess.minViewCells", mMergeMinViewCells);
-	environment->GetFloatValue("VspBspTree.PostProcess.maxCostRatio", mMergeMaxCostRatio);
-	environment->GetBoolValue("VspBspTree.PostProcess.useRaysForMerge", mUseRaysForMerge);
-
-
+	
 	//-- termination criteria for axis aligned split
 	environment->GetFloatValue("VspBspTree.Termination.AxisAligned.maxRayContribution", 
@@ -142,11 +112,11 @@
 	environment->GetFloatValue("VspBspTree.maxStaticMemory", mMaxMemory);
 
-	environment->GetBoolValue("VspBspTree.Visualization.exportMergedViewCells", mExportMergedViewCells);
-	environment->GetBoolValue("VspBspTree.PostProcess.exportMergeStats", mExportMergeStats);
-	
-
-	mStats.open("bspStats.log");
+	environment->GetFloatValue("VspBspTree.Construction.renderCostWeight", mRenderCostWeight);
+
+
+
 
 	//-- debug output
+
 	Debug << "******* VSP BSP options ******** " << endl;
     Debug << "max depth: " << mTermMaxDepth << endl;
@@ -162,6 +132,7 @@
 	Debug << "max plane candidates: " << mMaxRayCandidates << endl;
 	Debug << "randomize: " << randomize << endl;
-	Debug << "minimum view cells: " << mMergeMinViewCells << endl;
+//	Debug << "minimum view cells: " << mMergeMinViewCells << endl;
 	Debug << "using area for pvs: " << mUseAreaForPvs << endl;
+	Debug << "render cost weight: " << mRenderCostWeight << endl;
 	Debug << "Split plane strategy: ";
 
@@ -195,4 +166,5 @@
 	Debug << endl;
 }
+
 
 BspViewCell *VspBspTree::GetOutOfBoundsCell()
@@ -249,4 +221,5 @@
 	return (int)mesh->mFaces.size();
 }
+
 
 int VspBspTree::AddToPolygonSoup(const ViewCellContainer &viewCells,
@@ -273,4 +246,5 @@
 	return polysSize;
 }
+
 
 int VspBspTree::AddToPolygonSoup(const ObjectContainer &objects,
@@ -310,4 +284,5 @@
 }
 
+
 void VspBspTree::Construct(const VssRayContainer &sampleRays,
 						   AxisAlignedBox3 *forcedBoundingBox)
@@ -366,4 +341,5 @@
 	
 	Debug << "maximal pvs (i.e., pvs still considered as valid) : " << mViewCellsManager->GetMaxPvsSize() << endl;
+
 	//-- store rays
 	for (rit = sampleRays.begin(); rit != rit_end; ++ rit)
@@ -572,5 +548,5 @@
 		}
 		
-        viewCell->mLeaves.push_back(leaf);
+        viewCell->mLeaf = leaf;
 
 		if (mUseAreaForPvs)
@@ -589,6 +565,4 @@
 	return newNode;
 }
-
-
 
 
@@ -752,4 +726,5 @@
 }
 
+
 void VspBspTree::SortSplitCandidates(const RayInfoContainer &rays, const int axis)
 {
@@ -780,4 +755,5 @@
 	stable_sort(mSplitCandidates->begin(), mSplitCandidates->end());
 }
+
 
 float VspBspTree::BestCostRatioHeuristics(const RayInfoContainer &rays,
@@ -1035,4 +1011,401 @@
 
 
+bool VspBspTree::SelectPlane(Plane3 &bestPlane,
+							 BspLeaf *leaf,
+							 VspBspTraversalData &data,
+							 VspBspTraversalData &frontData,
+							 VspBspTraversalData &backData)
+{
+	// simplest strategy: just take next polygon
+	if (mSplitPlaneStrategy & RANDOM_POLYGON)
+	{
+        if (!data.mPolygons->empty())
+		{
+			const int randIdx = 
+				(int)RandomValue(0, (Real)((int)data.mPolygons->size() - 1));
+			Polygon3 *nextPoly = (*data.mPolygons)[randIdx];
+
+			bestPlane = nextPoly->GetSupportingPlane();
+			return true;
+		}
+	}
+
+	//-- use heuristics to find appropriate plane
+
+	// intermediate plane
+	Plane3 plane;
+	float lowestCost = MAX_FLOAT;
+	
+	// decides if the first few splits should be only axisAligned
+	const bool onlyAxisAligned  = 
+		(mSplitPlaneStrategy & AXIS_ALIGNED) &&
+		((int)data.mRays->size() > mTermMinRaysForAxisAligned) &&
+		((int)data.GetAvgRayContribution() < mTermMaxRayContriForAxisAligned);
+	
+	const int limit = onlyAxisAligned ? 0 : 
+		Min((int)data.mPolygons->size(), mMaxPolyCandidates);
+
+	float candidateCost;
+
+	int maxIdx = (int)data.mPolygons->size();
+
+	for (int i = 0; i < limit; ++ i)
+	{
+		// the already taken candidates are stored behind maxIdx
+		// => assure that no index is taken twice
+		const int candidateIdx = (int)RandomValue(0, (Real)(-- maxIdx));
+		Polygon3 *poly = (*data.mPolygons)[candidateIdx];
+
+		// swap candidate to the end to avoid testing same plane
+		std::swap((*data.mPolygons)[maxIdx], (*data.mPolygons)[candidateIdx]);
+		//Polygon3 *poly = (*data.mPolygons)[(int)RandomValue(0, (int)polys.size() - 1)];
+
+		// evaluate current candidate
+		BspNodeGeometry fGeom, bGeom;
+		float fArea, bArea;
+		plane = poly->GetSupportingPlane();
+		candidateCost = EvalSplitPlaneCost(plane, data, fGeom, bGeom, fArea, bArea);
+		
+		if (candidateCost < lowestCost)
+		{
+			bestPlane = plane;
+			lowestCost = candidateCost;
+		}
+	}
+
+	//-- evaluate axis aligned splits
+	int axis;
+	BspNodeGeometry *fGeom, *bGeom;
+	float pFront, pBack;
+
+	candidateCost = SelectAxisAlignedPlane(plane, data, axis,
+										   &fGeom, &bGeom, 
+										   pFront, pBack,
+										   data.mIsKdNode);	 
+
+	bool isAxisAlignedSplit = false;
+
+	if (candidateCost < lowestCost)
+	{	
+		bestPlane = plane;
+		lowestCost = candidateCost;
+
+		// assign already computed values
+		// we can do this because we always save the
+		// computed values from the axis aligned splits		
+		frontData.mGeometry = fGeom;
+		backData.mGeometry = bGeom;
+	
+		frontData.mProbability = pFront;
+		backData.mProbability = pBack;
+		
+		//! error also computed if cost ratio is missed
+		++ mBspStats.splits[axis];
+		isAxisAlignedSplit = true;
+	}
+	else
+	{
+		DEL_PTR(fGeom);
+		DEL_PTR(bGeom);
+	}
+
+	frontData.mIsKdNode = backData.mIsKdNode = (data.mIsKdNode && isAxisAlignedSplit);
+
+#ifdef _DEBUG
+	Debug << "plane lowest cost: " << lowestCost << endl;
+#endif
+
+	// cost ratio miss
+	if (lowestCost > mTermMaxCostRatio)
+		return false;
+
+	return true;
+}
+
+
+Plane3 VspBspTree::ChooseCandidatePlane(const RayInfoContainer &rays) const
+{
+	const int candidateIdx = (int)RandomValue(0, (Real)((int)rays.size() - 1));
+
+	const Vector3 minPt = rays[candidateIdx].ExtrapOrigin();
+	const Vector3 maxPt = rays[candidateIdx].ExtrapTermination();
+
+	const Vector3 pt = (maxPt + minPt) * 0.5;
+	const Vector3 normal = Normalize(rays[candidateIdx].mRay->GetDir());
+
+	return Plane3(normal, pt);
+}
+
+
+Plane3 VspBspTree::ChooseCandidatePlane2(const RayInfoContainer &rays) const
+{
+	Vector3 pt[3];
+
+	int idx[3];
+	int cmaxT = 0;
+	int cminT = 0;
+	bool chooseMin = false;
+
+	for (int j = 0; j < 3; ++ j)
+	{
+		idx[j] = (int)RandomValue(0, (Real)((int)rays.size() * 2 - 1));
+
+		if (idx[j] >= (int)rays.size())
+		{
+			idx[j] -= (int)rays.size();
+
+			chooseMin = (cminT < 2);
+		}
+		else
+			chooseMin = (cmaxT < 2);
+
+		RayInfo rayInf = rays[idx[j]];
+		pt[j] = chooseMin ? rayInf.ExtrapOrigin() : rayInf.ExtrapTermination();
+	}
+
+	return Plane3(pt[0], pt[1], pt[2]);
+}
+
+
+Plane3 VspBspTree::ChooseCandidatePlane3(const RayInfoContainer &rays) const
+{
+	Vector3 pt[3];
+
+	int idx1 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
+	int idx2 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
+
+	// check if rays different
+	if (idx1 == idx2)
+		idx2 = (idx2 + 1) % (int)rays.size();
+
+	const RayInfo ray1 = rays[idx1];
+	const RayInfo ray2 = rays[idx2];
+
+	// normal vector of the plane parallel to both lines
+	const Vector3 norm = Normalize(CrossProd(ray1.mRay->GetDir(), ray2.mRay->GetDir()));
+
+	// vector from line 1 to line 2
+	const Vector3 vd = ray2.ExtrapOrigin() - ray1.ExtrapOrigin();
+
+	// project vector on normal to get distance
+	const float dist = DotProd(vd, norm);
+
+	// point on plane lies halfway between the two planes
+	const Vector3 planePt = ray1.ExtrapOrigin() + norm * dist * 0.5;
+
+	return Plane3(norm, planePt);
+}
+
+
+inline void VspBspTree::GenerateUniqueIdsForPvs()
+{
+	Intersectable::NewMail(); sBackId = Intersectable::sMailId;
+	Intersectable::NewMail(); sFrontId = Intersectable::sMailId;
+	Intersectable::NewMail(); sFrontAndBackId = Intersectable::sMailId;
+}
+
+
+float VspBspTree::EvalSplitPlaneCost(const Plane3 &candidatePlane,
+									 const VspBspTraversalData &data,
+									 BspNodeGeometry &geomFront,
+									 BspNodeGeometry &geomBack,
+									 float &pFront,
+									 float &pBack) const
+{
+	float cost = 0;
+
+	float sumBalancedRays = 0;
+	float sumRaySplits = 0;
+
+	int pvsFront = 0;
+	int pvsBack = 0;
+
+	// probability that view point lies in back / front node
+	float pOverall = 0;
+	pFront = 0;
+	pBack = 0;
+
+	int raysFront = 0;
+	int raysBack = 0;
+	int totalPvs = 0;
+
+	int limit;
+	bool useRand;
+
+	// choose test rays randomly if too much
+	if ((int)data.mRays->size() > mMaxTests)
+	{
+		useRand = true;
+		limit = mMaxTests;
+	}
+	else
+	{
+		useRand = false;
+		limit = (int)data.mRays->size();
+	}
+	
+	for (int i = 0; i < limit; ++ i)
+	{
+		const int testIdx = useRand ? 
+			(int)RandomValue(0, (Real)((int)data.mRays->size() - 1)) : i;
+		RayInfo rayInf = (*data.mRays)[testIdx];
+
+		float t;
+		VssRay *ray = rayInf.mRay;
+		const int cf = rayInf.ComputeRayIntersection(candidatePlane, t);
+
+        if (0)
+		{
+			if (cf >= 0)
+				++ raysFront;
+			if (cf <= 0)
+				++ raysBack;
+		}
+
+		if (mSplitPlaneStrategy & LEAST_RAY_SPLITS)
+		{
+			sumBalancedRays += cf;
+		}
+
+		if (mSplitPlaneStrategy & BALANCED_RAYS)
+		{
+			if (cf == 0)
+				++ sumRaySplits;
+		}
+
+		if (mSplitPlaneStrategy & PVS)
+		{
+			// find front and back pvs for origing and termination object
+			AddObjToPvs(ray->mTerminationObject, cf, pvsFront, pvsBack, totalPvs);
+			AddObjToPvs(ray->mOriginObject, cf, pvsFront, pvsBack, totalPvs);
+		}
+	}
+
+	const float raysSize = (float)data.mRays->size() + Limits::Small;
+
+	if (mSplitPlaneStrategy & PVS)
+	{
+		// create unique ids for pvs heuristics
+		GenerateUniqueIdsForPvs();
+
+		// construct child geometry with regard to the candidate split plane
+		data.mGeometry->SplitGeometry(geomFront,
+									  geomBack,
+									  candidatePlane,
+									  mBox,
+									  mEpsilon);
+
+		pOverall = data.mProbability;
+
+		if (!mUseAreaForPvs) // use front and back cell areas to approximate volume
+		{
+			pFront = geomFront.GetVolume();
+			pBack = pOverall - geomFront.GetVolume();
+		}
+		else
+		{
+			pFront = geomFront.GetArea();
+			pBack = geomBack.GetArea();
+		}
+	}
+
+
+	if (mSplitPlaneStrategy & LEAST_RAY_SPLITS)
+		cost += mLeastRaySplitsFactor * sumRaySplits / raysSize;
+
+	if (mSplitPlaneStrategy & BALANCED_RAYS)
+		cost += mBalancedRaysFactor * fabs(sumBalancedRays) / raysSize;
+
+	// -- pvs rendering heuristics
+	if (mSplitPlaneStrategy & PVS)
+	{
+		const int lowerPvsLimit = mViewCellsManager->GetMinPvsSize();
+		const int upperPvsLimit = mViewCellsManager->GetMaxPvsSize();
+
+		// only render cost heuristics or combined with standard deviation
+		if (1)
+		{
+			const float penaltyOld = EvalPvsPenalty(totalPvs, lowerPvsLimit, upperPvsLimit);
+         	const float penaltyFront = EvalPvsPenalty(pvsFront, lowerPvsLimit, upperPvsLimit);
+			const float penaltyBack = EvalPvsPenalty(pvsBack, lowerPvsLimit, upperPvsLimit);
+			
+			const float oldRenderCost = pOverall * (float)penaltyOld + Limits::Small;
+			const float newRenderCost = penaltyFront * pFront + penaltyBack * pBack;
+
+			float oldCost, newCost;
+
+			if (1)
+			{
+				oldCost = oldRenderCost;
+				newCost = newRenderCost;
+			}
+			else
+			{
+				// standard deviation is difference of back and front pvs
+				const float expectedCost = 0.5f * (penaltyFront + penaltyBack);
+
+				const float newDeviation = 0.5f * 
+					fabs(penaltyFront - expectedCost) + fabs(penaltyBack - expectedCost);
+
+                const float oldDeviation = penaltyOld + Limits::Small;
+
+				newCost = mRenderCostWeight * newRenderCost + (1.0f - mRenderCostWeight) * newDeviation;
+				oldCost = mRenderCostWeight * oldRenderCost + (1.0f - mRenderCostWeight) * oldDeviation;
+			}
+
+			cost += mPvsFactor * newCost / oldCost;
+		}
+		else
+		{
+			//-- compute weighted sum of expected render cost and standard deviation
+			
+			//-- first compute expected render cost		
+			const float penaltyOld = EvalPvsPenalty(totalPvs, lowerPvsLimit, upperPvsLimit);
+         	const float penaltyFront = EvalPvsPenalty(pvsFront, lowerPvsLimit, upperPvsLimit);
+			const float penaltyBack = EvalPvsPenalty(pvsBack, lowerPvsLimit, upperPvsLimit);
+			
+			const float renderCostFront = penaltyFront * pFront;
+			const float renderCostBack = penaltyBack * pBack;
+
+			const float oldRenderCost = pOverall * (float)penaltyOld + Limits::Small;
+			const float newRenderCost = renderCostFront + renderCostBack;
+
+
+			//-- compute standard deviation
+			const float expectedCost = 0.5f * (renderCostBack + renderCostFront);
+
+			const float devFront = fabs(renderCostFront - expectedCost);
+			
+			const float devBack = fabs(renderCostBack - expectedCost);
+
+			const float newDev = 0.5f * (devFront + devBack);
+			const float oldDev = oldRenderCost * oldRenderCost;
+
+			const float newCost = newRenderCost * mRenderCostWeight + newDev * (1.0f - mRenderCostWeight);
+			const float oldCost = oldRenderCost * mRenderCostWeight + oldDev * (1.0f - mRenderCostWeight);
+
+			cost += mPvsFactor * newCost / oldCost;
+
+			// also try to equalize render differences between front and back pvs
+			//const float oldCost = pOverall + Limits::Small;
+			//float newCost = (float)abs(pvsFront - pvsBack);
+			
+		}
+	}
+
+#ifdef _DEBUG
+  	Debug << "totalpvs: " << data.mPvs << " ptotal: " << pOverall
+  		  << " frontpvs: " << pvsFront << " pFront: " << pFront
+  		  << " backpvs: " << pvsBack << " pBack: " << pBack << endl << endl;
+#endif
+
+	// normalize cost by sum of linear factors
+	if(0)
+		return cost / (float)mCostNormalizer;
+	else
+		return cost;
+}
+
+
 float VspBspTree::EvalAxisAlignedSplitCost(const VspBspTraversalData &data,
 										   const AxisAlignedBox3 &box,
@@ -1110,353 +1483,4 @@
 
 	return  (mCtDivCi + newCost) / oldCost;
-}
-
-
-
-bool VspBspTree::SelectPlane(Plane3 &bestPlane,
-							 BspLeaf *leaf,
-							 VspBspTraversalData &data,
-							 VspBspTraversalData &frontData,
-							 VspBspTraversalData &backData)
-{
-	// simplest strategy: just take next polygon
-	if (mSplitPlaneStrategy & RANDOM_POLYGON)
-	{
-        if (!data.mPolygons->empty())
-		{
-			const int randIdx = 
-				(int)RandomValue(0, (Real)((int)data.mPolygons->size() - 1));
-			Polygon3 *nextPoly = (*data.mPolygons)[randIdx];
-
-			bestPlane = nextPoly->GetSupportingPlane();
-			return true;
-		}
-	}
-
-	//-- use heuristics to find appropriate plane
-
-	// intermediate plane
-	Plane3 plane;
-	float lowestCost = MAX_FLOAT;
-	
-	// decides if the first few splits should be only axisAligned
-	const bool onlyAxisAligned  = 
-		(mSplitPlaneStrategy & AXIS_ALIGNED) &&
-		((int)data.mRays->size() > mTermMinRaysForAxisAligned) &&
-		((int)data.GetAvgRayContribution() < mTermMaxRayContriForAxisAligned);
-	
-	const int limit = onlyAxisAligned ? 0 : 
-		Min((int)data.mPolygons->size(), mMaxPolyCandidates);
-
-	float candidateCost;
-
-	int maxIdx = (int)data.mPolygons->size();
-
-	for (int i = 0; i < limit; ++ i)
-	{
-		// the already taken candidates are stored behind maxIdx
-		// => assure that no index is taken twice
-		const int candidateIdx = (int)RandomValue(0, (Real)(-- maxIdx));
-		Polygon3 *poly = (*data.mPolygons)[candidateIdx];
-
-		// swap candidate to the end to avoid testing same plane
-		std::swap((*data.mPolygons)[maxIdx], (*data.mPolygons)[candidateIdx]);
-		//Polygon3 *poly = (*data.mPolygons)[(int)RandomValue(0, (int)polys.size() - 1)];
-
-		// evaluate current candidate
-		BspNodeGeometry fGeom, bGeom;
-		float fArea, bArea;
-		plane = poly->GetSupportingPlane();
-		candidateCost = EvalSplitPlaneCost(plane, data, fGeom, bGeom, fArea, bArea);
-		
-		if (candidateCost < lowestCost)
-		{
-			bestPlane = plane;
-			lowestCost = candidateCost;
-		}
-	}
-
-	//-- evaluate axis aligned splits
-	int axis;
-	BspNodeGeometry *fGeom, *bGeom;
-	float pFront, pBack;
-
-	candidateCost = SelectAxisAlignedPlane(plane, data, axis,
-										   &fGeom, &bGeom, 
-										   pFront, pBack,
-										   data.mIsKdNode);	 
-
-	bool isAxisAlignedSplit = false;
-
-	if (candidateCost < lowestCost)
-	{	
-		bestPlane = plane;
-		lowestCost = candidateCost;
-
-		// assign already computed values
-		// we can do this because we always save the
-		// computed values from the axis aligned splits		
-		frontData.mGeometry = fGeom;
-		backData.mGeometry = bGeom;
-	
-		frontData.mProbability = pFront;
-		backData.mProbability = pBack;
-		
-		//! error also computed if cost ratio is missed
-		++ mBspStats.splits[axis];
-		isAxisAlignedSplit = true;
-	}
-	else
-	{
-		DEL_PTR(fGeom);
-		DEL_PTR(bGeom);
-	}
-
-	frontData.mIsKdNode = backData.mIsKdNode = (data.mIsKdNode && isAxisAlignedSplit);
-
-#ifdef _DEBUG
-	Debug << "plane lowest cost: " << lowestCost << endl;
-#endif
-
-	// cost ratio miss
-	if (lowestCost > mTermMaxCostRatio)
-		return false;
-
-	return true;
-}
-
-
-Plane3 VspBspTree::ChooseCandidatePlane(const RayInfoContainer &rays) const
-{
-	const int candidateIdx = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-
-	const Vector3 minPt = rays[candidateIdx].ExtrapOrigin();
-	const Vector3 maxPt = rays[candidateIdx].ExtrapTermination();
-
-	const Vector3 pt = (maxPt + minPt) * 0.5;
-	const Vector3 normal = Normalize(rays[candidateIdx].mRay->GetDir());
-
-	return Plane3(normal, pt);
-}
-
-
-Plane3 VspBspTree::ChooseCandidatePlane2(const RayInfoContainer &rays) const
-{
-	Vector3 pt[3];
-
-	int idx[3];
-	int cmaxT = 0;
-	int cminT = 0;
-	bool chooseMin = false;
-
-	for (int j = 0; j < 3; ++ j)
-	{
-		idx[j] = (int)RandomValue(0, (Real)((int)rays.size() * 2 - 1));
-
-		if (idx[j] >= (int)rays.size())
-		{
-			idx[j] -= (int)rays.size();
-
-			chooseMin = (cminT < 2);
-		}
-		else
-			chooseMin = (cmaxT < 2);
-
-		RayInfo rayInf = rays[idx[j]];
-		pt[j] = chooseMin ? rayInf.ExtrapOrigin() : rayInf.ExtrapTermination();
-	}
-
-	return Plane3(pt[0], pt[1], pt[2]);
-}
-
-Plane3 VspBspTree::ChooseCandidatePlane3(const RayInfoContainer &rays) const
-{
-	Vector3 pt[3];
-
-	int idx1 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-	int idx2 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-
-	// check if rays different
-	if (idx1 == idx2)
-		idx2 = (idx2 + 1) % (int)rays.size();
-
-	const RayInfo ray1 = rays[idx1];
-	const RayInfo ray2 = rays[idx2];
-
-	// normal vector of the plane parallel to both lines
-	const Vector3 norm = Normalize(CrossProd(ray1.mRay->GetDir(), ray2.mRay->GetDir()));
-
-	// vector from line 1 to line 2
-	const Vector3 vd = ray2.ExtrapOrigin() - ray1.ExtrapOrigin();
-
-	// project vector on normal to get distance
-	const float dist = DotProd(vd, norm);
-
-	// point on plane lies halfway between the two planes
-	const Vector3 planePt = ray1.ExtrapOrigin() + norm * dist * 0.5;
-
-	return Plane3(norm, planePt);
-}
-
-
-inline void VspBspTree::GenerateUniqueIdsForPvs()
-{
-	Intersectable::NewMail(); sBackId = ViewCell::sMailId;
-	Intersectable::NewMail(); sFrontId = ViewCell::sMailId;
-	Intersectable::NewMail(); sFrontAndBackId = ViewCell::sMailId;
-}
-
-
-float VspBspTree::EvalSplitPlaneCost(const Plane3 &candidatePlane,
-									 const VspBspTraversalData &data,
-									 BspNodeGeometry &geomFront,
-									 BspNodeGeometry &geomBack,
-									 float &pFront,
-									 float &pBack) const
-{
-	float cost = 0;
-
-	float sumBalancedRays = 0;
-	float sumRaySplits = 0;
-
-	int pvsFront = 0;
-	int pvsBack = 0;
-
-	// probability that view point lies in back / front node
-	float pOverall = 0;
-	pFront = 0;
-	pBack = 0;
-
-	int raysFront = 0;
-	int raysBack = 0;
-	int totalPvs = 0;
-
-	int limit;
-	bool useRand;
-
-	// choose test rays randomly if too much
-	if ((int)data.mRays->size() > mMaxTests)
-	{
-		useRand = true;
-		limit = mMaxTests;
-	}
-	else
-	{
-		useRand = false;
-		limit = (int)data.mRays->size();
-	}
-	
-	for (int i = 0; i < limit; ++ i)
-	{
-		const int testIdx = useRand ? 
-			(int)RandomValue(0, (Real)((int)data.mRays->size() - 1)) : i;
-		RayInfo rayInf = (*data.mRays)[testIdx];
-
-		float t;
-		VssRay *ray = rayInf.mRay;
-		const int cf = rayInf.ComputeRayIntersection(candidatePlane, t);
-
-        if (0)
-		{
-			if (cf >= 0)
-				++ raysFront;
-			if (cf <= 0)
-				++ raysBack;
-		}
-
-		if (mSplitPlaneStrategy & LEAST_RAY_SPLITS)
-		{
-			sumBalancedRays += cf;
-		}
-
-		if (mSplitPlaneStrategy & BALANCED_RAYS)
-		{
-			if (cf == 0)
-				++ sumRaySplits;
-		}
-
-		if (mSplitPlaneStrategy & PVS)
-		{
-			// find front and back pvs for origing and termination object
-			AddObjToPvs(ray->mTerminationObject, cf, pvsFront, pvsBack, totalPvs);
-			AddObjToPvs(ray->mOriginObject, cf, pvsFront, pvsBack, totalPvs);
-		}
-	}
-
-	const float raysSize = (float)data.mRays->size() + Limits::Small;
-
-	if (mSplitPlaneStrategy & PVS)
-	{
-		// create unique ids for pvs heuristics
-		GenerateUniqueIdsForPvs();
-
-		// construct child geometry with regard to the candidate split plane
-		data.mGeometry->SplitGeometry(geomFront,
-									  geomBack,
-									  candidatePlane,
-									  mBox,
-									  mEpsilon);
-
-		pOverall = data.mProbability;
-
-		if (!mUseAreaForPvs) // use front and back cell areas to approximate volume
-		{
-			pFront = geomFront.GetVolume();
-			pBack = pOverall - geomFront.GetVolume();
-		}
-		else
-		{
-			pFront = geomFront.GetArea();
-			pBack = geomBack.GetArea();
-		}
-	}
-
-
-	if (mSplitPlaneStrategy & LEAST_RAY_SPLITS)
-		cost += mLeastRaySplitsFactor * sumRaySplits / raysSize;
-
-	if (mSplitPlaneStrategy & BALANCED_RAYS)
-		cost += mBalancedRaysFactor * fabs(sumBalancedRays) / raysSize;
-
-	// pvs criterium
-	if (mSplitPlaneStrategy & PVS)
-	{
-		if (1)
-		{
-			const int lowerPvsLimit = mViewCellsManager->GetMinPvsSize();
-			const int upperPvsLimit = mViewCellsManager->GetMaxPvsSize();
-			
-			const float penaltyOld = EvalPvsPenalty(totalPvs, lowerPvsLimit, upperPvsLimit);
-            
-			const float penaltyFront = EvalPvsPenalty(pvsFront, lowerPvsLimit, upperPvsLimit);
-			const float penaltyBack = EvalPvsPenalty(pvsBack, lowerPvsLimit, upperPvsLimit);
-			
-			const float oldCost = pOverall * (float)penaltyOld + Limits::Small;
-			cost += mPvsFactor * (penaltyFront * pFront + penaltyBack * pBack) / oldCost;
-
-		}
-		else
-		{
-			// try to equalize render differences
-			//const float oldCost = pOverall * (float)totalPvs + Limits::Small;
-			//float newCost = fabs(pvsFront * pFront - pvsBack * pBack);
-			const float oldCost = pOverall + Limits::Small;
-			float newCost = (float)abs(pvsFront - pvsBack);
-
-			cost += mPvsFactor * newCost / oldCost;
-		}
-	}
-
-#ifdef _DEBUG
-  	Debug << "totalpvs: " << data.mPvs << " ptotal: " << pOverall
-  		  << " frontpvs: " << pvsFront << " pFront: " << pFront
-  		  << " backpvs: " << pvsBack << " pBack: " << pBack << endl << endl;
-#endif
-
-	// normalize cost by sum of linear factors
-	if(0)
-		return cost / (float)mCostNormalizer;
-	else
-		return cost;
 }
 
@@ -1731,9 +1755,13 @@
 			{
 				BspViewCell *viewCell = dynamic_cast<BspLeaf *>(node)->GetViewCell();
-			
-				vector<BspLeaf *>::const_iterator it, it_end = viewCell->mLeaves.end();
-				for (it = viewCell->mLeaves.begin();it != it_end; ++ it)
+	
+				ViewCellContainer leaves;
+				mViewCellsManager->GetViewCellsTree()->CollectLeaves(viewCell, leaves);
+
+				ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+				for (it = leaves.begin(); it != it_end; ++ it)
 				{
-					BspLeaf *l = *it;
+					BspLeaf *l = dynamic_cast<BspViewCell *>(*it)->mLeaf;
 					l->SetViewCell(GetOrCreateOutOfBoundsCell());
 					++ mBspStats.invalidLeaves;
@@ -2024,9 +2052,14 @@
 								   BspNodeGeometry &vcGeom) const
 {
-	vector<BspLeaf *> leaves = vc->mLeaves;
-	vector<BspLeaf *>::const_iterator it, it_end = leaves.end();
+	ViewCellContainer leaves;
+	mViewCellsManager->GetViewCellsTree()->CollectLeaves(vc, leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
 
 	for (it = leaves.begin(); it != it_end; ++ it)
-		ConstructGeometry(*it, vcGeom);
+	{
+		BspLeaf *l = dynamic_cast<BspViewCell *>(*it)->mLeaf;
+		ConstructGeometry(l, vcGeom);
+	}
 }
 
@@ -2456,4 +2489,5 @@
 }
 
+
 BspNode *VspBspTree::CollapseTree(BspNode *node, int &collapsed)
 {
@@ -2499,10 +2533,11 @@
 {
 	int collapsed = 0;
-	
+	//TODO
+#if VC_HISTORY
 	(void)CollapseTree(mRoot, collapsed);
 
 	// revalidate leaves
 	RepairViewCellsLeafLists();
-
+#endif
 	return collapsed;
 }
@@ -2527,5 +2562,6 @@
 
 			BspViewCell *viewCell = leaf->GetViewCell();
-
+	// TODO
+#if VC_HISTORY
 			if (!viewCell->Mailed())
 			{
@@ -2533,6 +2569,8 @@
 				viewCell->Mail();
 			}
-
+	
 			viewCell->mLeaves.push_back(leaf);
+// TODO
+#endif
 		}
 		else
@@ -2631,69 +2669,4 @@
 
 
-bool VspBspTree::MergeViewCells(BspLeaf *l1, BspLeaf *l2) //const
-{
-	//-- change pointer to view cells of all leaves associated
-	//-- with the previous view cells
-	BspViewCell *fVc = l1->GetViewCell();
-	BspViewCell *bVc = l2->GetViewCell();
-
-	BspViewCell *vc = dynamic_cast<BspViewCell *>(
-		mViewCellsManager->MergeViewCells(*fVc, *bVc));
-
-	// if merge was unsuccessful
-	if (!vc) return false;
-
-	// set new size of view cell
-	if (mUseAreaForPvs)
-		vc->SetArea(fVc->GetArea() + bVc->GetArea());
-	else
-		vc->SetVolume(fVc->GetVolume() + bVc->GetVolume());
-	
-	vector<BspLeaf *> fLeaves = fVc->mLeaves;
-	vector<BspLeaf *> bLeaves = bVc->mLeaves;
-
-	vector<BspLeaf *>::const_iterator it;
-
-	//-- change view cells of all the other leaves the view cell belongs to
-	for (it = fLeaves.begin(); it != fLeaves.end(); ++ it)
-	{
-		(*it)->SetViewCell(vc);
-		vc->mLeaves.push_back(*it);
-	}
-
-	for (it = bLeaves.begin(); it != bLeaves.end(); ++ it)
-	{
-		(*it)->SetViewCell(vc);
-		vc->mLeaves.push_back(*it);
-	}
-
-	// important so other merge candidates sharing this view cell
-	// are notified that the merge cost must be updated!!
-	vc->Mail();
-
-	//-- clean up old view cells
-	if (mExportMergedViewCells)
-	{
-		DEL_PTR(fVc);
-		DEL_PTR(bVc);
-	}
-	else 
-	{
-		// old view cells container needed for visualization
-		//fVc->mMailbox = -1;
-		//bVc->mMailbox = -1;
-		fVc->SetId(-2);
-		bVc->SetId(-2);
-
-		mOldViewCells.push_back(fVc);
-		mOldViewCells.push_back(bVc);
-		
-		mNewViewCells.push_back(vc);
-	}
-
-	return true;
-}
-
-
 void VspBspTree::SetViewCellsManager(ViewCellsManager *vcm)
 {
@@ -2702,5 +2675,6 @@
 
 
-int VspBspTree::CollectMergeCandidates(const vector<BspLeaf *> leaves)
+int VspBspTree::CollectMergeCandidates(const vector<BspLeaf *> leaves,
+									   vector<MergeCandidate> &candidates)
 {
 	BspLeaf::NewMail();
@@ -2708,5 +2682,5 @@
 	vector<BspLeaf *>::const_iterator it, it_end = leaves.end();
 
-	int candidates = 0;
+	int numCandidates = 0;
 
 	// find merge candidates and push them into queue
@@ -2714,10 +2688,4 @@
 	{
 		BspLeaf *leaf = *it;
-		
-		/// create leaf pvs (needed for post processing)
-		leaf->mPvs = new ObjectPvs(leaf->GetViewCell()->GetPvs());
-
-		//const float rc = leaf->mProbability * (float)leaf->mPvs->GetSize();
-		//BspMergeCandidate::sOverallCost += rc;
 		
 		// the same leaves must not be part of two merge candidates
@@ -2733,12 +2701,11 @@
 			if ((*nit)->GetViewCell() != leaf->GetViewCell())
 			{
-				BspMergeCandidate mc(leaf, *nit);
-				mc.EvalMergeCost();
-
-				mMergeQueue.push(mc);
-				++ candidates;
-				if ((candidates % 1000) == 0)
+				MergeCandidate mc(leaf->GetViewCell(), (*nit)->GetViewCell());
+				candidates.push_back(mc);
+
+				++ numCandidates;
+				if ((numCandidates % 1000) == 0)
 				{
-					cout << "collected " << candidates << " merge candidates" << endl;
+					cout << "collected " << numCandidates << " merge candidates" << endl;
 				}
 			}
@@ -2746,8 +2713,7 @@
 	}
 
-	Debug << "mergequeue: " << (int)mMergeQueue.size() << endl;
-	Debug << "leaves in queue: " << candidates << endl;
-	Debug << "overall cost: " << BspMergeCandidate::sOverallCost << endl;
-
+	Debug << "merge queue: " << (int)candidates.size() << endl;
+	Debug << "leaves in queue: " << numCandidates << endl;
+	
 
 	return (int)leaves.size();
@@ -2755,5 +2721,6 @@
 
 
-int VspBspTree::CollectMergeCandidates(const VssRayContainer &rays)
+int VspBspTree::CollectMergeCandidates(const VssRayContainer &rays, 
+									   vector<MergeCandidate> &candidates)
 {
 	ViewCell::NewMail();
@@ -2775,20 +2742,8 @@
 		if (ray->mViewCells.size() < 2)
 			continue;
-	  
+//TODO viewcellhierarchy
 		iit = ray->mViewCells.begin();
 		BspViewCell *bspVc = dynamic_cast<BspViewCell *>(*(iit ++));
-		BspLeaf *leaf = bspVc->mLeaves[0];
-		
-		// create leaf pvs (needed for post processing)
-		if (!leaf->mPvs)
-		{
-			leaf->mPvs = 
-				new ObjectPvs(leaf->GetViewCell()->GetPvs());
-
-			//BspMergeCandidate::sOverallCost += 
-			//	leaf->mProbability * leaf->mPvs->GetSize();
-			
-			++ numLeaves;
-		}
+		BspLeaf *leaf = bspVc->mLeaf;
 		
 		// traverse intersections 
@@ -2799,5 +2754,5 @@
 			BspLeaf *prevLeaf = leaf;
 			bspVc = dynamic_cast<BspViewCell *>(*iit);
-            leaf = bspVc->mLeaves[0];
+            leaf = bspVc->mLeaf;
 
 			// view space not valid or same view cell
@@ -2806,17 +2761,5 @@
 				continue;
 
-            // create leaf pvs (needed for post processing)
-			if (!leaf->mPvs)
-			{
-				leaf->mPvs = 
-					new ObjectPvs(leaf->GetViewCell()->GetPvs());
-				
-				//BspMergeCandidate::sOverallCost += 
-				//	leaf->mProbability * leaf->mPvs->GetSize();
-
-				++ numLeaves;
-			}
-		
-			vector<BspLeaf *> &neighbors = neighborMap[leaf];
+           	vector<BspLeaf *> &neighbors = neighborMap[leaf];
 			
 			bool found = false;
@@ -2843,12 +2786,11 @@
 				prevLeaf->Mail();
 		
-				BspMergeCandidate mc(leaf, prevLeaf);
-				mc.EvalMergeCost();
-
-				mMergeQueue.push(mc);
-
-				if (((int)mMergeQueue.size() % 1000) == 0)
+				MergeCandidate mc(leaf->GetViewCell(), prevLeaf->GetViewCell());
+				
+				candidates.push_back(mc);
+
+				if (((int)candidates.size() % 1000) == 0)
 				{
-					cout << "collected " << (int)mMergeQueue.size() << " merge candidates" << endl;
+					cout << "collected " << (int)candidates.size() << " merge candidates" << endl;
 				}
 			}
